#coding:utf8

from .XtViewClient import QmtDataComClient
import time

CLIENT = None

from os.path import abspath, dirname
__curdir = dirname(abspath(__file__))

__rpc_config = __curdir + '/xtdata.ini'
__xtview_config = __curdir + '/xtdata.ini'

from .IPythonApiClient import rpc_init
__rpc_init_status = rpc_init(__rpc_config)
print(__rpc_init_status)
if __rpc_init_status < 0:
    print(f'rpc初始化失败，配置文件：{__rpc_config}')

def getClient():
    global CLIENT
    if not CLIENT:
        CLIENT = QmtDataComClient('client_xtview', __xtview_config)
        if not CLIENT:
            raise Exception("创建连接失败！")
    if not CLIENT.is_connected():
        if not CLIENT.connect():
            raise Exception("无法连接展示端！")
    return CLIENT


def createView(viewID, type=0, title='', groupId=-1):
    '''
        type: 0, 1, 2
    '''
    client = getClient()
    client.createView(viewID, type, title, groupId)

def destoryView(viewID):
    client = getClient()
    client.removeView(viewID)

def pushViewData(viewID, time, datas):
    '''
        time_list: [time1, time2, ...]
        datas: {code_a : [a1, a2, ...], code_b : [b1, b2, ...], ...}
    '''
    client = getClient()
    if type(time) == int:
        name_list = list(datas.keys())
        value_list = []
        for name in name_list:
            value_list.append([datas[name]])
        client.pushViewData(viewID, [time], name_list, value_list)
        return
    if type(time) == list:
        time_list = time
        name_list = list(datas.keys())
        value_list = list(datas.values())
        client.pushViewData(viewID, time_list, name_list, value_list)
        return

def pushCustomData(data_type, time, datas, arrive_flag = 1):
    '''
        time_list: [time1, time2, ...]
        datas: {code_a : [a1, a2, ...], code_b : [b1, b2, ...], ...}
    '''
    client = getClient()
    if type(time) == int:
        name_list = list(datas.keys())
        value_list = []
        for name in name_list:
            value_list.append([datas[name]])
        client.pushCustomData(data_type, [time], name_list, value_list, arrive_flag)
        return
    if type(time) == list:
        time_list = time
        name_list = list(datas.keys())
        value_list = list(datas.values())
        client.pushCustomData(data_type, time_list, name_list, value_list, arrive_flag)
        return
